Index: /trunk/src/game/Level2.cpp
===================================================================
--- /trunk/src/game/Level2.cpp (revision 230)
+++ /trunk/src/game/Level2.cpp (revision 260)
@@ -2362,6 +2362,6 @@
     // Check
     // Remember: "show" must also be the name of a column!
-    if( (show != "emote") && (show != "spell") && (show != "text1") && (show != "text2")
-        && (show != "text3") && (show != "text4") && (show != "text5")
+    if( (show != "emote") && (show != "spell") && (show != "textid1") && (show != "textid2")
+        && (show != "textid3") && (show != "textid4") && (show != "textid5")
         && (show != "waittime") && (show != "del") && (show != "move") && (show != "add")
         && (show != "model1") && (show != "model2") && (show != "orientation"))
@@ -2703,4 +2703,11 @@
         PSendSysMessage(LANG_WAYPOINT_CREATNOTFOUND, lowguid);
         SetSentErrorMessage(true);
+        return false;
+    }
+
+    // set in game textids not supported
+    if( show == "textid1" || show == "textid2" || show == "textid3" ||
+        show == "textid4" || show == "textid5" )
+    {
         return false;
     }
@@ -2843,5 +2850,5 @@
 
         QueryResult *result =
-            WorldDatabase.PQuery( "SELECT id, point, waittime, emote, spell, text1, text2, text3, text4, text5, model1, model2 FROM creature_movement WHERE wpguid = %u",
+            WorldDatabase.PQuery( "SELECT id, point, waittime, emote, spell, textid1, textid2, textid3, textid4, textid5, model1, model2 FROM creature_movement WHERE wpguid = %u",
             target->GetGUIDLow() );
         if(!result)
@@ -2855,5 +2862,5 @@
             PSendSysMessage(LANG_WAYPOINT_NOTFOUNDSEARCH, target->GetGUID());
 
-            result = WorldDatabase.PQuery( "SELECT id, point, waittime, emote, spell, text1, text2, text3, text4, text5, model1, model2 FROM creature_movement WHERE (abs(position_x - %f) <= %s ) and (abs(position_y - %f) <= %s ) and (abs(position_z - %f) <= %s )",
+            result = WorldDatabase.PQuery( "SELECT id, point, waittime, emote, spell, textid1, textid2, textid3, textid4, textid5, model1, model2 FROM creature_movement WHERE (abs(position_x - %f) <= %s ) and (abs(position_y - %f) <= %s ) and (abs(position_z - %f) <= %s )",
                 target->GetPositionX(), maxDIFF, target->GetPositionY(), maxDIFF, target->GetPositionZ(), maxDIFF);
             if(!result)
@@ -2872,9 +2879,7 @@
             uint32 emote            = fields[3].GetUInt32();
             uint32 spell            = fields[4].GetUInt32();
-            const char * text1      = fields[5].GetString();
-            const char * text2      = fields[6].GetString();
-            const char * text3      = fields[7].GetString();
-            const char * text4      = fields[8].GetString();
-            const char * text5      = fields[9].GetString();
+            uint32 textid[MAX_WAYPOINT_TEXT];
+            for(int i = 0;  i < MAX_WAYPOINT_TEXT; ++i)
+                textid[i]           = fields[5+i].GetUInt32();
             uint32 model1           = fields[10].GetUInt32();
             uint32 model2           = fields[11].GetUInt32();
@@ -2889,9 +2894,6 @@
             PSendSysMessage(LANG_WAYPOINT_INFO_EMOTE, emote);
             PSendSysMessage(LANG_WAYPOINT_INFO_SPELL, spell);
-            PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, 1, text1);
-            PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, 2, text2);
-            PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, 3, text3);
-            PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, 4, text4);
-            PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, 5, text5);
+            for(int i = 0;  i < MAX_WAYPOINT_TEXT; ++i)
+                PSendSysMessage(LANG_WAYPOINT_INFO_TEXT, i+1, textid[i], (textid[i] ? GetTrinityString(textid[i]) : ""));
 
         }while( result->NextRow() );
@@ -3214,6 +3216,6 @@
 
     QueryResult *result = WorldDatabase.PQuery(
-    //          0      1           2           3           4            5       6       7         8      9      10     11     12     13     14     15
-        "SELECT point, position_x, position_y, position_z, orientation, model1, model2, waittime, emote, spell, text1, text2, text3, text4, text5, id FROM creature_movement WHERE id = '%u' ORDER BY point", lowguid );
+    //          0      1           2           3           4            5       6       7         8      9      10       11       12       13       14       15
+        "SELECT point, position_x, position_y, position_z, orientation, model1, model2, waittime, emote, spell, textid1, textid2, textid3, textid4, textid5, id FROM creature_movement WHERE id = '%u' ORDER BY point", lowguid );
 
     if (!result)
@@ -3232,5 +3234,5 @@
 
         outfile << "INSERT INTO creature_movement ";
-        outfile << "( id, point, position_x, position_y, position_z, orientation, model1, model2, waittime, emote, spell, text1, text2, text3, text4, text5 ) VALUES ";
+        outfile << "( id, point, position_x, position_y, position_z, orientation, model1, model2, waittime, emote, spell, textid1, textid2, textid3, textid4, textid5 ) VALUES ";
 
         outfile << "( ";
@@ -3257,63 +3259,13 @@
         outfile << fields[9].GetUInt32();                   // spell
         outfile << ", ";
-        const char *tmpChar = fields[10].GetString();
-        if( !tmpChar )
-        {
-            outfile << "NULL";                              // text1
-        }
-        else
-        {
-            outfile << "'";
-            outfile << tmpChar;                             // text1
-            outfile << "'";
-        }
+        outfile << fields[10].GetUInt32();                  // textid1
         outfile << ", ";
-        tmpChar = fields[11].GetString();
-        if( !tmpChar )
-        {
-            outfile << "NULL";                              // text2
-        }
-        else
-        {
-            outfile << "'";
-            outfile << tmpChar;                             // text2
-            outfile << "'";
-        }
+        outfile << fields[11].GetUInt32();                  // textid2
         outfile << ", ";
-        tmpChar = fields[12].GetString();
-        if( !tmpChar )
-        {
-            outfile << "NULL";                              // text3
-        }
-        else
-        {
-            outfile << "'";
-            outfile << tmpChar;                             // text3
-            outfile << "'";
-        }
+        outfile << fields[12].GetUInt32();                  // textid3
         outfile << ", ";
-        tmpChar = fields[13].GetString();
-        if( !tmpChar )
-        {
-            outfile << "NULL";                              // text4
-        }
-        else
-        {
-            outfile << "'";
-            outfile << tmpChar;                             // text4
-            outfile << "'";
-        }
+        outfile << fields[13].GetUInt32();                  // textid4
         outfile << ", ";
-        tmpChar = fields[14].GetString();
-        if( !tmpChar )
-        {
-            outfile << "NULL";                              // text5
-        }
-        else
-        {
-            outfile << "'";
-            outfile << tmpChar;                             // text5
-            outfile << "'";
-        }
+        outfile << fields[14].GetUInt32();                  // textid5
         outfile << ");\n ";
 
Index: /trunk/src/game/ItemPrototype.h
===================================================================
--- /trunk/src/game/ItemPrototype.h (revision 257)
+++ /trunk/src/game/ItemPrototype.h (revision 260)
@@ -11,10 +11,10 @@
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
@@ -100,5 +100,7 @@
     ITEM_FLAGS_USEABLE_IN_ARENA               = 0x00200000,
     ITEM_FLAGS_THROWABLE                      = 0x00400000, // not used in game for check trow possibility, only for item in game tooltip
-    ITEM_FLAGS_SPECIALUSE                     = 0x00800000  // last used flag in 2.3.0
+    ITEM_FLAGS_SPECIALUSE                     = 0x00800000, // last used flag in 2.3.0
+    ITEM_FLAGS_BOA                            = 0x08000000, // bind on account
+    ITEM_FLAGS_MILLABLE                       = 0x20000000
 };
 
@@ -107,7 +109,7 @@
     BAG_FAMILY_MASK_ARROWS                    = 0x00000001,
     BAG_FAMILY_MASK_BULLETS                   = 0x00000002,
-    BAG_FAMILY_MASK_SHARDS                    = 0x00000004,
+    BAG_FAMILY_MASK_SOUL_SHARDS               = 0x00000004,
     BAG_FAMILY_MASK_LEATHERWORKING_SUPP       = 0x00000008,
-    BAG_FAMILY_MASK_UNUSED                    = 0x00000010, // not used currently
+    BAG_FAMILY_MASK_INSCRIPTION_SUPP          = 0x00000010,
     BAG_FAMILY_MASK_HERBS                     = 0x00000020,
     BAG_FAMILY_MASK_ENCHANTING_SUPP           = 0x00000040,
@@ -117,10 +119,8 @@
     BAG_FAMILY_MASK_MINING_SUPP               = 0x00000400,
     BAG_FAMILY_MASK_SOULBOUND_EQUIPMENT       = 0x00000800,
-    BAG_FAMILY_MASK_VANITY_PETS               = 0x00001000
-};
-
-/* TODO: Not entirely positive on need for this??
-enum SOCKET_CONTENT ();
-*/
+    BAG_FAMILY_MASK_VANITY_PETS               = 0x00001000,
+    BAG_FAMILY_MASK_CURRENCY_TOKENS           = 0x00002000,
+    BAG_FAMILY_MASK_QUEST_ITEMS               = 0x00004000
+};
 
 enum SocketColor
@@ -276,5 +276,5 @@
 };
 
-#define MAX_ITEM_SUBCLASS_ARMOR                  10
+#define MAX_ITEM_SUBCLASS_ARMOR                   10
 
 enum ItemSubclassReagent
@@ -390,4 +390,20 @@
 
 #define MAX_ITEM_SUBCLASS_JUNK                    6
+
+enum ItemSubclassGlyph
+{
+    ITEM_SUBCLASS_GLYPH_WARRIOR                 = 1,
+    ITEM_SUBCLASS_GLYPH_PALADIN                 = 2,
+    ITEM_SUBCLASS_GLYPH_HUNTER                  = 3,
+    ITEM_SUBCLASS_GLYPH_ROGUE                   = 4,
+    ITEM_SUBCLASS_GLYPH_PRIEST                  = 5,
+    ITEM_SUBCLASS_GLYPH_DEATH_KNIGHT            = 6,
+    ITEM_SUBCLASS_GLYPH_SHAMAN                  = 7,
+    ITEM_SUBCLASS_GLYPH_MAGE                    = 8,
+    ITEM_SUBCLASS_GLYPH_WARLOCK                 = 9,
+    ITEM_SUBCLASS_GLYPH_DRUID                   = 11
+};
+
+#define MAX_ITEM_SUBCLASS_GLYPH                   12
 
 const uint32 MaxItemSubclassValues[MAX_ITEM_CLASS] =
@@ -525,5 +541,5 @@
     uint32 RequiredDisenchantSkill;
     float  ArmorDamageModifier;
-    char* ScriptName;
+    uint32 ScriptId;
     uint32 DisenchantID;
     uint32 FoodType;
Index: /trunk/src/game/WaypointManager.h
===================================================================
--- /trunk/src/game/WaypointManager.h (revision 206)
+++ /trunk/src/game/WaypointManager.h (revision 260)
@@ -26,9 +26,10 @@
 #include "Utilities/UnorderedMap.h"
 
+#define MAX_WAYPOINT_TEXT 5
 struct WaypointBehavior
 {
     uint32 emote;
     uint32 spell;
-    std::string text[5];
+    int32  textid[MAX_WAYPOINT_TEXT];
     uint32 model1;
     uint32 model2;
Index: /trunk/src/game/AuctionHouse.cpp
===================================================================
--- /trunk/src/game/AuctionHouse.cpp (revision 229)
+++ /trunk/src/game/AuctionHouse.cpp (revision 260)
@@ -11,10 +11,10 @@
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
@@ -90,6 +90,6 @@
         return false;
     }
-    data << auction->Id;
-    data << pItem->GetUInt32Value(OBJECT_FIELD_ENTRY);
+    data << (uint32) auction->Id;
+    data << (uint32) pItem->GetEntry();
 
     for (uint8 i = 0; i < MAX_INSPECTED_ENCHANTMENT_SLOT; i++)
@@ -246,5 +246,5 @@
         return;
     }
-    // prevent sending bag with items (cheat: can be placed in bag after adding equipped empty bag to auction)
+    // prevent sending bag with items (cheat: can be placed in bag after adding equiped empty bag to auction)
     if(!it)
     {
@@ -717,5 +717,5 @@
                                             if (il)
                                             {
-                                                if (il->Name.size() > loc_idx && !il->Name[loc_idx].empty())
+                                                if (il->Name.size() > size_t(loc_idx) && !il->Name[loc_idx].empty())
                                                     name = il->Name[loc_idx];
                                             }
